<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suifmath.texi on 28 April 1999 -->

<TITLE>The SUIFMATH Library - Inequality Manipulation</TITLE>
<link href="suifmath_11.html" rel=Next>
<link href="suifmath_9.html" rel=Previous>
<link href="suifmath_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_9.html">previous</A>, <A HREF="suifmath_11.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC10" HREF="suifmath_toc.html#TOC10">Linear Inequality Manipulation</A></H2>
<P>
<A NAME="IDX201"></A>
<A NAME="IDX202"></A>
<A NAME="IDX203"></A>
<A NAME="IDX204"></A>
<A NAME="IDX205"></A>
<A NAME="IDX206"></A>

</P>
<P>
All the routines given in section <A HREF="suifmath_4.html#SEC4">Matrix Manipulation</A> also apply to
linear inequalities.  
The symbols <VAR>A</VAR>, <VAR>B</VAR> and  <VAR>C</VAR> are of the class
<CODE>lin_ineq</CODE>; <VAR>a</VAR> is a single inequality of the class
<CODE>constraint</CODE> and <VAR>m</VAR>, <VAR>n</VAR>, <VAR>i</VAR> and
<VAR>j</VAR> are integers.

</P>
<DL COMPACT>

<DT><CODE>num_variables();</CODE>
<DD>
<A NAME="IDX207"></A>
Number of variables. Same as <CODE>n()</CODE>.

<DT><CODE>num_constraints();</CODE>
<DD>
<A NAME="IDX208"></A>
Number of Constraints. Same as <CODE>m()</CODE>.

<DT><CODE>is_empty();</CODE>
<DD>
<A NAME="IDX209"></A>
Number of Constraints is zero? 

<DT><CODE>lin_ineq A(r, c);</CODE>
<DD>
<DT><CODE>A.init(r, c);</CODE>
<DD>
<DT><CODE>lin_ineq A(B);</CODE>
<DD>
<DT><CODE>lin_ineq A(&#38;B);</CODE>
<DD>
<DT><CODE>A.init(B);</CODE>
<DD>
<DT><CODE>A.init(&#38;B);</CODE>
<DD>
<A NAME="IDX210"></A>
<A NAME="IDX211"></A>
<A NAME="IDX212"></A>
<A NAME="IDX213"></A>
<A NAME="IDX214"></A>
Initialize and create inequalities. More functions can be found in
See section <A HREF="suifmath_4.html#SEC4">Matrix Manipulation</A>.

<DT><CODE>coeff cf;</CODE>
<DD>
<DT><CODE>lin_ineq A(cf);</CODE>
<DD>
<DT><CODE>lin_ineq A(&#38;cf);</CODE>
<DD>
<DT><CODE>A.init(cf);</CODE>
<DD>
<DT><CODE>A.init(&#38;cf);</CODE>
<DD>
<A NAME="IDX215"></A>
<A NAME="IDX216"></A>
<A NAME="IDX217"></A>
<A NAME="IDX218"></A>
<A NAME="IDX219"></A>
Class <CODE>cf</CODE> is a data structure used in dependence testing. These
will convert the information in <CODE>cf</CODE> to the linear inequality
format. 

<DT><CODE>FILE * fp;</CODE>
<DD>
<DT><CODE>lin_ineq A(fp);</CODE>
<DD>
<DT><CODE>lin_ineq A(fp, i, j);</CODE>
<DD>
<DT><CODE>A.init(fp);</CODE>
<DD>
<DT><CODE>A.init(fp, i, j);</CODE>
<DD>
<A NAME="IDX220"></A>
<A NAME="IDX221"></A>
<A NAME="IDX222"></A>
<A NAME="IDX223"></A>
<A NAME="IDX224"></A>
<A NAME="IDX225"></A>
<A NAME="IDX226"></A>
This interface provides a mechanism to read in a matrix directly from a
file. The format is two integers indicating the number of rows and
columns of the matrix followed by a list of integers representing the
elements in row major order. All integers can only  be separated by
white space, tab or new lines.  If the number of rows and columns are
specified in the function, the file should not contain the first two
integers with the same information.

<DT><CODE>A = B.conjunct(C);</CODE>
<DD>
<DT><CODE>A = B &#38; C;</CODE>
<DD>
<A NAME="IDX227"></A>
<A NAME="IDX228"></A>
The function <CODE>conjunct</CODE> and the operator <CODE>&#38;</CODE> perform a
Conjunction on the two systems of inequalities.
</DL>

<P><HR><P>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_9.html">previous</A>, <A HREF="suifmath_11.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
</BODY>
</HTML>
